#define debounce_btn 250                    //      - 
#define debounce_enc 100                    //     - 
#define beep_time 330                       //   -    
#define OUT PORTA.F6                        //    
#define BUZZER PORTB.F2                     //  
#define CNT_BTN PORTB.F7                    //    
#define RUN_BTN PORTB.F0                    //   
#define ACT_BTN PORTB.F4                    //   
#define ENC_PORT PORTB                      //   
#define ENC_A_PIN F5                        //  
#define ENC_B_PIN F6                        //      
#define ENC_BITS 0b01100000                 //  : 5  6  , 5  6  
//                 76543210                 //    -    
////////////////////////////////////////////// RA5 -   !!!     !!! ////////////////////////////////////

//      ,   -----------------------------------------------------------------------
//  
sbit LCD_RS at RA1_bit;
sbit LCD_EN at RA0_bit;
sbit LCD_D4 at RA2_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RA3_bit;
sbit LCD_D7 at RA4_bit;
sbit LCD_RS_Direction at TRISA1_bit;
sbit LCD_EN_Direction at TRISA0_bit;
sbit LCD_D4_Direction at TRISA2_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISA3_bit;
sbit LCD_D7_Direction at TRISA4_bit;
//   ---------------------------------------------------------------------------------------------------------------------

//--------------------------------------------  -------------------------------------------------------------------------------
bit  beep_on, contin, cycle, in_menu, in_preset, normal, run;
char new_encoder, old_encoder, position, preset_nr;
char delay, delay1, delay2, delay3, delay4, delay_old;
char time, time1, time2, time3, time4, time_old;
char brtnss_txt[4], delay_txt[4], preset_nr_txt[4], time_txt[4];
char brtnss;
short encoder, encoder_tmp, i;


// ++++++++++++++++++++++++++++++++++++++++++  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ------------------------------------------  --------------------------------------------------------------------------------
void menu_SCR(void)                        //    
 {
  Lcd_Out(1, 1, "PR1  PR2");
  Lcd_Out(2, 1, "PR4  PR3");
 }
 
void preset_SCR(void)                       //   
 {
  ByteToStr(time, time_txt);                //     
  ByteToStr(delay, delay_txt);
  Lcd_Out(1, 1, time_txt);                  //  :
  Lcd_Chr(1, 1, 0x2E);                      //       ,  .
  Lcd_Out(1, 6, delay_txt);                 // ..   , ,  
  Lcd_Out(1, 7, delay_txt);                 //   120  1,2 -     
  Lcd_Chr(1, 7, 0x2E);                      //  ,    .
  Lcd_Out(2, 1, "CNT  EXT");
 }
 
void time_SCR(void)                         //    
 {
  Lcd_Cmd(_LCD_CLEAR);                      //  
  if (time != time_old) Lcd_Chr(1, 1, 0x21);//         
   else Lcd_Chr(1, 1, 0x2B);                //     - 
  ByteToStr(time, time_txt);                //     
  Lcd_Out(1, 3, time_txt);                  //   
  Lcd_Chr(1, 3, 0x2E);                      //  
  Lcd_Chr(1, 8, preset_nr+48);              // 0 -  48-  ASCII, ..      10,    48
  Lcd_Out(2, 2, "NORMAL");
 }
 
void cycle_SCR(void)                        //   
 {  Lcd_Cmd(_LCD_CLEAR);                    //  
  if (delay != delay_old) Lcd_Chr(1, 1, 0x21);//         
   else Lcd_Chr(1, 1, 0x2B);                //     - 
  ByteToStr(delay, delay_txt);              //     
  Lcd_Out(1, 3, delay_txt);                 //   
  Lcd_Out(1, 4, delay_txt);                 //    
  Lcd_Chr(1, 4, 0x2E);                      //  
  Lcd_Chr(1, 6, 0x20);                      //   -   
  Lcd_Chr(1, 8, preset_nr+48);              // 0 -  48-  ASCII, ..      10,    48
  Lcd_Out(2, 2, "CYCLE");
 }

void contin_SCR(void)                       //   
 {
  Lcd_Out(1, 1, "   --   ");
  Lcd_Chr(1, 8, preset_nr+48);              // 0 -  48-  ASCII, ..      10,    48
  Lcd_Out(2, 1, " CONTIN ");
 }
// ------------------------------------------   --------------------------------------------------------------------------

// ------------------------------------------   -----------------------------------------------------------------------
void cursor_MOV(char)
 { 
  Lcd_Chr(1, 4, 0x20);                      //      
  Lcd_Chr(1, 5, 0x20);
  Lcd_Chr(2, 4, 0x20);
  Lcd_Chr(2, 5, 0x20);
  switch (position)                         //   ( <  >)   
   {
    case 1:
     Lcd_Chr(1, 4, 0x3C);                   // <
     break;                                 //   ,      
    case 2:
     Lcd_Chr(1, 5, 0x3E);                   // >
     break;
    case 3:
     Lcd_Chr(2, 5, 0x3E);
     break;
    case 4:
     Lcd_Chr(2, 4, 0x3C);                   //       
   }
}// ------------------------------------------    ----------------------------------------------------------------

//--------------------------------------------            --------------
void read_timings(char)
 {
  switch(preset_nr)                         //           
   {
    case 1:
      time_old = time = EEPROM_Read(0x01);
      delay_old = delay = EEPROM_Read(0x02);
      break;
    case 2:
      time_old = time = EEPROM_Read(0x03);
      delay_old = delay = EEPROM_Read(0x04);
      break;
    case 3:
      time_old = time = EEPROM_Read(0x05);
      delay_old = delay = EEPROM_Read(0x06);
      break;
    case 4:
      time_old = time = EEPROM_Read(0x07);
      delay_old = delay = EEPROM_Read(0x08);
   }
}//------------------------------------------    EEPROM -----------------------------------------------------------------

//-------------------------------------------   -------------------------------------------------------------------------
void beep(void)
 {
  if(beep_on)
   {
    BUZZER = 1;                               //    1,    
    delay_ms(beep_time);                      //       
    BUZZER = 0;                               //   0
   }
  delay_ms(beep_time);                        //   ,       
 }//------------------------------------------   -------------------------------------------------------------------------

//--------------------------------------------  SAVED   -----------------------------------------------------------------
void saved(void)
{
 Lcd_Out(2, 1, "  SAVED ");
 delay_ms(250);
 beep();
}//-------------------------------------------   SAVED   -----------------------------------------------------------

//--------------------------------------------  ,  ,   1,   0 --------------------------
char encoder_change(void)
 {
  new_encoder = ENC_PORT & ENC_BITS;        //     
  delay_us(debounce_enc);                   //  
  if(new_encoder != old_encoder)            //    - 
   {
    if(new_encoder.ENC_A_PIN == old_encoder.ENC_B_PIN) encoder_tmp++;
     else encoder_tmp--;
    old_encoder = new_encoder;              //  ,      
   }
   if (encoder_tmp == 3 || encoder_tmp == -3)
   {                                        //      
    if(encoder_tmp == 3) encoder = 1;
    if(encoder_tmp == -3) encoder = -1;     //    
    encoder_tmp = 0;                        //    
    return 1;                               //    1 - 
   }
    else return 0;                          //  0 -  .
 }//-------------------------------------------   ------------------------------------------------------------------------
//++++++++++++++++++++++++++++++++++++++++++++   ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//============================================  ============================================================================
void interrupt(void)
 {
  if(INTCON.INT0IF && normal && !run)       //   RB0     
   {
    INT0IE_bit = 0;                         //    RB0
    run = 1;                                //   
    OUT = 1;                                //  
    vdelay_ms(time*10);                     //        10 ,  
    OUT = 0;                                //  
    for(;;) if (RUN_BTN) break;             //  ,   ,    
    run = 0;                                //   
    INTCON.INT0IF = 0;                      //   
    delay_ms(debounce_btn);                 //   
    INT0IE_bit = 1;                         //    RB0
   }
   
  if(INTCON.INT0IF && contin && !run)       //   RB0     
   {
    INT0IE_bit = 0;                         //    RB0
    delay_ms(10);                           //    -  ,    - 
    run = 1;                                //   
    OUT = 1;                                //  
    for(;;) if (RUN_BTN) break;             //  ,   ,    
    OUT = 0;                                //  
    run = 0;                                //   
    INTCON.INT0IF = 0;                      //   
    INT0IE_bit = 1;                         //    RB0
   }
   
  if(INTCON.INT0IF && cycle && !run)        //   RB0     
   {
    INT0IE_bit = 0;                         //    RB0
    run = 1;                                //   
    beep();                                 //  -   
    for(;;)                                 //    
     {
      OUT = 1;                              //  
      vdelay_ms(time*10);                   //        10 ,  
      OUT = 0;                              //  
      vdelay_ms(delay*10);                  //   -    10
      if(!RUN_BTN)                          //      :
       {
        run = 0;                            //   
        INTCON.INT0IF = 0;                  //   
        INT0IE_bit = 1;                     //    RB0
        beep();                             //  
        beep();
        break;                              //   
       }
     }
   }
  if(INTCON.INT0IF) INTCON.INT0IF = 0;      //   ,      ,   
 }//==========================================   ======================================================================

//============================================  ==================================================================================
void main()
{
  OSCCON = 0b01111100;                      // 8MHz,  
//           |||||||+------------------------- 0 SCS: 1-0  
//           ||||||+-------------------------- 1 00 -  FOSC, 01 - T1OSC, 10 - INTRC, 11 -   
//           |||||+--------------------------- 2 IOFS: : 1 -  , 0 - 
//           ||||+---------------------------- 3 OSTS: : 1 -  , 0 - T1OSC  INTRC   
//           |||+----------------------------- 4 IRCF: 6-4   
//           ||+------------------------------ 5 000 - 31,25   001 - 125    010 - 250    011 - 500 
//           |+------------------------------- 6 100 - 1       101 - 2      110 - 4      111 - 8
//           +-------------------------------- 7 -  ,   0

  OPTION_REG = 0b00001111;                  //      RB0  
//               |||||||+--------------------- 0 2-0  ,   WDT,    TMR0,     2
//               ||||||+---------------------- 1 000 - 1:1   001 - 1:2   010 - 1:4   011 - 1:8
//               |||||+----------------------- 2 100 - 1:16  101 - 1:32  110 - 1:64  111 - 1:128
//               ||||+------------------------ 3 PSA:    1 - WDT, 0 - TMR0
//               |||+------------------------- 4 T0SE:       TMR0  T1OSC
//               ||+-------------------------- 5 T0CS:     TMR0 1 - T0CKI pin, 0 -  CLKO
//               |+--------------------------- 6 INTEDG:       RB0: 1 - , 0 - 
//               +---------------------------- 7 RBPU:    : 0 , 1 - 

  INTCON = 0b00000000;                      //  
//           |||||||+------------------------- 0 RBIF: RB Port Change Interrupt Flag, 1 - , 0 -  
//           ||||||+-------------------------- 1 INT0IF: RB0/INT External Interrupt Flag
//           |||||+--------------------------- 2 TMR0IF: TMR0 Overflow Interrupt Flag
//           ||||+---------------------------- 3 RBIE: RB Port Change Interrupt Enable, 1 - , 0 - 
//           |||+----------------------------- 4 INT0IE: RB0/INT External Interrupt Enable
//           ||+------------------------------ 5 TMR0IE: TMR0 Overflow Interrupt Enable
//           |+------------------------------- 6 PEIE: Peripheral Interrupt Enable
//           +-------------------------------- 7 GIE: Global Interrupt Enable
                                            //            , :
// OPTION_REG.F7 = 0;                       //     
// OPTION_REG.INTEDG = 1;                   //     RB0

  ANSEL = 0;                                //   
  TRISA = 0;                                //    
  TRISB = 0;                                //  B  
  PORTB = 0;                                //     0,     
  PORTA = 0;                                //    ,     
  brtnss = EEPROM_Read(0x09);               //       
  if(brtnss > 100)                          //     ,    
   {
    EEPROM_Write(0x00, 1);                  //      
    EEPROM_Write(0x01, 10);                 //  , ,  -   
    EEPROM_Write(0x03, 20);                 //   c 
    EEPROM_Write(0x05, 30);                 // ..     
    EEPROM_Write(0x07, 40);
    EEPROM_Write(0x02, 110);
    EEPROM_Write(0x04, 120);
    EEPROM_Write(0x06, 230);
    EEPROM_Write(0x08, 240);
    EEPROM_Write(0x09, 50);
    EEPROM_Write(0x10, 1);
   }
  beep_on = EEPROM_Read(0x10);
  contin = cycle = in_menu = in_preset = normal = run = 0; //  
  old_encoder = 33;                         //       ,      
  PWM1_Init(500);                           //       
  PWM1_Set_Duty(brtnss*255/100);            //  
  PWM1_Start();                             //  
  TRISB = 0b11110001;                       //    ,  ,    -  1  RB0,   
  Lcd_Init();                               //    
  Lcd_Cmd(_LCD_CURSOR_OFF);                 //  
  Lcd_Out(1, 1, " Visit  ");                //  
  Lcd_Out(2, 1, " cxo.lv ");  
  beep();                                   // 
  delay_ms(500);                            //  
  
//--------------------------------------------     ,       --------------------
  if(!ACT_BTN)                              //        
   {
    beep();                                 //  -   
    delay_ms(1000);
    Lcd_Cmd(_LCD_CLEAR);                    //    
    ByteToStr(brtnss, brtnss_txt);          //     
    Lcd_Out(1, 3, brtnss_txt);              //   
    Lcd_Out(2, 1, "BRIGHTNS");
    for(;;)                                 //   ,      
     {
      if (encoder_change())                 //       1 -  
       {
        brtnss = brtnss + (brtnss*encoder/10)+encoder;//     10%,    1%
        if(brtnss <= 1)                     //     ,    
         {
          brtnss = 1;                       //  1%
          i = 1;                            //     
         }
        if(brtnss >= 100)                   // 100%
         {
          brtnss = 100;
          i = 1;                            //     
         }
        ByteToStr(brtnss, brtnss_txt);      //     
        Lcd_Out(1, 3, brtnss_txt);          //   
        PWM1_Set_Duty(brtnss*255/100);      //   
        if (i)                              //     
         {
          i = 0;                            //  
          beep();                           // 
         }
       }

      if(!ACT_BTN)                          //       
       {
        EEPROM_Write(0x09, brtnss);         //     EEPROM
        saved();                            //  
        beep();                             //     
        break;                              //    
       }
     }                                      //       
     
    Lcd_Cmd(_LCD_CLEAR);                    //   
    Lcd_Out(1, 3, "BEEP");
    for(;;)
     {
      if (beep_on) Lcd_Out(2, 4, "ON ");
       else Lcd_Out(2, 4, "OFF");
      if (encoder_change()) beep_on = ~beep_on;

      if(!ACT_BTN)                          //       
       {
        EEPROM_Write(0x10, beep_on);        //   EEPROM
        saved();                            //  
        Lcd_Cmd(_LCD_CLEAR);                //  
        beep();
        break;                              //    
       }                                    //       

      }
   }//------------------------------------------      ---------------------------------------------------

//--------------------------------------------     ---------------------------------------------------
  preset_nr = EEPROM_Read(0x00);            //        
  read_timings(preset_nr);                  //     
  normal = 1;                               //    
  time_SCR();                               //    
  INTCON = 0b10010000;                      //    RB0  

//============================================ ,     ==========================================================
  for(;;)
  {// ++++++++++++++++++++++++++++++++++++++++     ++++++++++++++++++++++++++++++++++++++++++++++++
   if (encoder_change())                    //       1
    {
     if(in_menu)                            //    
      {
       position = position + encoder;       //     
       if(position >= 5) position = 1;      //   
       if(position <= 0) position = 4;
       preset_nr = position;                //    
       cursor_MOV(position);                //     
      }
      
     if(in_preset)                          //   -   
      {
       position = position + encoder;       //      
       if(position >= 5) position = 1;      //   
       if(position <= 0) position = 4;
       cursor_MOV(position);                //      
      }

     if(normal)                             //   -  
      {
       time = time + time*encoder/10;       //     10%  
       if(time <= 10)                       //      0,1  -     
        {                                   //      - 
         time = 10;                         //   
         i = 1;                             //     
        }
       if(time >= 99)                       //      0,99  -    
        {
         time = 99;                         //   
         i = 1;                             //     
        }
       time_SCR();                          //    
       if (i)                               //       
        {
         i = 0;                             //   
         beep();                            // 
        }
      }
      
     if(cycle)                              //  -  
      {
       delay = delay + encoder*10;          //      
       if(delay < 50)
        {
         delay = 50;                        //   
         i = 1;
        }
       if(delay > 240)
        {
         delay = 240;                       //  2,4 
         i = 1;
        }
       cycle_SCR();
       if (i)
        {
         i = 0;
         beep();
        }
      }
    }//+++++++++++++++++++++++++++++++++++++++     +++++++++++++++++++++++++++++++++++++++++++++++++++

// +++++++++++++++++++++++++++++++++++++++++++      ++++++++++++++++++++++++++++++++++++++++++
   if(!ACT_BTN)                             //   
    {
     delay_ms(debounce_btn);                //   
     for(;;)                                //     ,      () 
      {
       if(in_menu)                          //      
        {
         in_menu = 0;                       //     
         normal = 1;                        //      
         read_timings(preset_nr);           //     
         time_SCR();                        //    
         EEPROM_Write(0x00, preset_nr);     //   ,       
         break;                             //    
        }//-----------------------------------        ------------------------------------------

       if(in_preset)                        //      
        {
         read_timings(preset_nr);           //     ,     
         switch(position)
          {
           case 1:                          //  1 -  ,   
             normal = 1;
             time_SCR();
             break;
           case 2:                          //  2 -  ,    
             cycle = 1;
             normal = 0;
             cycle_SCR();
             break;
           case 3:                          //  3 -     
             in_menu = 1;                   //   
             encoder = position = preset_nr;//       - 
             menu_SCR();                    //   
             cursor_MOV(preset_nr);         //    ,     
             break;
           case 4:                          //  4 -  ,   /  
             contin = 1;                    //   
             normal = 0;
             contin_SCR();                  //    
             break;
          }
         in_preset = 0;                     //     
         break;                             //    
        }//-----------------------------------        -------------------------------------

// -------------------------------------------       -------------------------------------------
       if(normal)                           //    -   
        {
         in_preset = 1;                     //   
         if (time != time_old)              //      ,  
          {
           if(preset_nr == 1) EEPROM_Write(0x01, time);
           if(preset_nr == 2) EEPROM_Write(0x03, time);
           if(preset_nr == 3) EEPROM_Write(0x05, time);
           if(preset_nr == 4) EEPROM_Write(0x07, time);
           saved();
          }
         normal = 0;
         preset_SCR();                      //   
         position = 3;                      //      
         cursor_MOV(position);
         break;                             //    
        }
        
       if(cycle)                            //     -   
        {
         in_preset = 1;                     //   
         if(delay != delay_old)             //     ,  
          {
           if(preset_nr == 1) EEPROM_Write(0x02, delay);
           if(preset_nr == 2) EEPROM_Write(0x04, delay);
           if(preset_nr == 3) EEPROM_Write(0x06, delay);
           if(preset_nr == 4) EEPROM_Write(0x08, delay);
           saved();
          }
         cycle = 0;                                                        
         preset_SCR();                      //   
         position = 3;                      //    
         cursor_MOV(position);              //     
         break;                             //    
        }
        
       if(contin)                           //        -    
        {
         contin = 0;
         normal = 1;
         time_SCR();
         break;
        }
      }//-------------------------------------      -------------------------------------------------
    }//---------------------------------------     -------------------------------------------------------

// -------------------------------------------      --------------------------------------------
   if(!CNT_BTN && normal)                   //            ,   
    {
     contin = 1;
     normal = 0;
     contin_SCR();
     beep();                                //   -     
    }

   if(!CNT_BTN && contin)                   //  -    
    {
     contin = 0;
     normal = 1;
     time_SCR();
     beep();                                //   -     
     beep();
    }// --------------------------------------       --------------------------------------
  }//=========================================    ==================================================================
}//===========================================   ============================================================================